/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _ECHONEST_PROVIDER_H_
#define _ECHONEST_PROVIDER_H_

#include <QByteArray>
#include <QString>
#include <QStringList>
#include <QtCore>

#include "provider_base.h"

//! ECHONEST LIBRARY
#include <src3party/libechonest/Artist.h>
/*
********************************************************************************
*                                                                              *
*    Class EchonestProvider                                                    *
*                                                                              *
********************************************************************************
*/
class EchonestProvider : public QObject, public InfoProvider
{
Q_OBJECT
  public :
    EchonestProvider(QObject* parent=0);
    ~EchonestProvider();
    
    void init();
    void cancel_searches();
    void fetch_info(int id);
    void fetch_artist_bio(int id);
    void fetch_artist_image(int id);
    void fetch_artist_similar(int id);

  private slots:
    void slot_fetch_artist_bio_done();
    void slot_fetch_artist_image_done();
    void slot_artist_image_fetched(QByteArray bytes);
    void slot_fetch_artist_similar_done();
    
  private:
    QMap<QObject*, int>     m_requests;
    QMap<QObject*, Echonest::Artist*> m_echonest_artists;
    
  signals:
    void ArtistBioOK(int id, QString provider, QString bio);
    void ArtistImageOK(int id, QByteArray bytes);
    void ArtistSimilarOK(int id, QStringList similarArtist);
};

#endif // _ECHONEST_PROVIDER_H_
