/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _LASTFM_PROVIDER_H_
#define _LASTFM_PROVIDER_H_

#include <QByteArray>
#include <QString>
#include <QPixmap>
#include <QtCore>

#include "provider_base.h"

/*
********************************************************************************
*                                                                              *
*    Class LastFmProvider                                                      *
*                                                                              *
********************************************************************************
*/
class LastFmProvider : public QObject, public InfoProvider
{
Q_OBJECT
  public :
    LastFmProvider(QObject* parent=0);
    ~LastFmProvider();
    
    void init();
    void cancel_searches();
    void fetch_info(int id);
    
  private:
    void fetch_album_info(int id);

  private slots:
    void slot_fetch_album_info_done(QByteArray bytes);
    void slot_album_image_done(QByteArray bytes);
    
  private:
    QMap<QObject*, int>     m_requests;      

  signals:
    void AlbumBioOK(int id, QString bio);
    void AlbumImageOK(int id, QByteArray bytes);  
};


#endif // _LASTFM_PROVIDER_H_
