/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MEDIAMIMEDATA_H
#define _MEDIAMIMEDATA_H


#include <QMimeData>
#include <QStringList>
#include <QString>


#include "MediaItem/mediaitem.h"


const QString MEDIA_MIME = "application/x-yarockplayer-media";

enum E_MEDIA_SOURCE   {SOURCE_COLLECTION, SOURCE_PLAYQUEUE};

/*
********************************************************************************
*                                                                              *
*    Class MediaMimeData                                                       *
*                                                                              *
********************************************************************************
*/
class MediaMimeData : public QMimeData
{
  public:
    MediaMimeData();

    virtual QStringList formats() const;
    
    virtual bool hasFormat( const QString &mimeType ) const;

    QList<MediaItemPtr> getMediaItem() const { return _listMediaItem; }

    void addMediaItem(const MediaItemPtr mi);

    void addMediaItemList(QList<MediaItemPtr> list);

    E_MEDIA_SOURCE source() {return _source;}
    
    void setSource(E_MEDIA_SOURCE  so) {_source = so;}
    E_MEDIA_SOURCE      _source;

  private:
    QList<MediaItemPtr> _listMediaItem;
};

#endif // _MEDIAMIMEDATA_H
