/* YaRock Player
* Copyright (C) 2010-2013 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _ICECAST_MANAGER_H_
#define _ICECAST_MANAGER_H_


#include "MediaItem/mediaitem.h"

#include <QList>
#include <QByteArray>
#include <QObject>
/*
********************************************************************************
*                                                                              *
*    Class IceCastManager                                                      *
*                                                                              *
********************************************************************************
*/
class IceCastManager : public QObject
{
Q_OBJECT
  public:
    IceCastManager();
    QList<MediaItemPtr> getIceCastStream() const;
    bool isReady();
    bool isError();
    void startDownload();
    void setDuplicate(bool b) {_showDuplicate = b;}

  private:
    bool _isUpdating;
    bool _isError;
    int  _downloadTry;
    bool _showDuplicate;
        
  private slots:
    void sendRequest();
    void parseResponse(QByteArray bytes);
    QList<MediaItemPtr> readFile() const;
    void iceCastStop();
    
  signals:
    void iceCastUpdated();
};

#endif // _ICECAST_MANAGER_H_
